	.dbfile C:\iccv7arm\MI5020~1\MicroBolt_I2C_EEPROM.c
	AREA	"Cidata", DATA
	EXPORT _EepromDataValue
_EepromDataValue:
	DCB 0
	.dbsym e EepromDataValue _EepromDataValue c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 42
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBolt_I2C_EEPROM.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 12/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include "MicroBolt_I2C_EEPROM.h"
; #include "MicroBolt_I2C_Functions.h"
; #include "SerialDebugger.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; unsigned char EepromDataValue = 0;
; unsigned int Delay, ReadCount;
; 
; void main(void)
;   {
	.dbline 44
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 51
; 
; /*
; |-------------------------
; | Config MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 52
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 54
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 61
; 
; /*
; |-------------------------
; | Config PLL and CCLK 
; |-------------------------
; */
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+8
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 62
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+12
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 63
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 64
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 71
; 
; /*
; |-------------------------
; | Config PCLK 
; |-------------------------
; */
;   SCB_VPBDIV = 0;                               // Peripheral clock is 1/4th Processor clock which equals 14.7456 MHz
	mov R4,#0
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 78
; 
; /*
; |-------------------------
; | Configure VIC 
; |-------------------------
; */
;   VICVectAddr0 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+24
	ldr R5,LIT_main+28
	str R4,[R5,#0]
	.dbline 79
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 80
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 82
; 
; 	VICVectAddr1 = (unsigned)I2c_ISR;							// Assign the I2C ISR vector address 
	ldr R4,LIT_main+40
	ldr R5,LIT_main+44
	str R4,[R5,#0]
	.dbline 83
;   VICVectCntl1 = INTERRUPT_CHANNEL_FOR_I2C;     // Assign the VIC address to the actual interrupt
	mov R4,#41
	ldr R5,LIT_main+48
	str R4,[R5,#0]
	.dbline 84
;   VICIntEnable = INTERRUPT_ENABLE_FOR_I2C;      // Enable the interrupt 
	mov R4,#512
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 91
; 
; /*
; |-------------------------
; | Config GPIO 
; |-------------------------
; */
;   PCB_PINSEL0=0x00000055;                       // Setup with ICCARM App builder - MicroBolt_I2C_EEPROM.bcf (I2C & UART0)   
	mov R4,#85
	ldr R5,LIT_main+52
	str R4,[R5,#0]
	.dbline 92
;   PCB_PINSEL1=0x55400000;                       //                                   (Secondary JTAG pins) 
	ldr R4,LIT_main+56
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 94
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+64
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 96
; 
;   GPIO_IOCLR=0xffffffff;                        // Clear all pins to start with
	mvn R4,#0
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 103
; 
; /*
; |-------------------------
; | Config UART-O 
; |-------------------------
; */
;   UART0_IER = 0x00000001;	 	                   // Receive interrupts
	mov R4,#1
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 104
;   UART0_FCR = 0x00000001;	 	                   // Enable the fifos
	mov R4,#1
	ldr R5,LIT_main+76
	str R4,[R5,#0]
	.dbline 105
;   UART0_LCR = 0x00000083;	 	                   // Enable the divisor
	mov R4,#131
	ldr R5,LIT_main+80
	str R4,[R5,#0]
	.dbline 106
;   UART0_DLM = 0;				                       // Divisor latch MSB (for baud rates < 4800) 
	mov R4,#0
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 107
;   UART0_DLL = BAUD_RATE_115200;			           // Divisor latch LSB 
	mov R4,#8
	ldr R5,LIT_main+84
	str R4,[R5,#0]
	.dbline 108
;   UART0_LCR = 0x00000003;  	                   // Close it, then UART works with divisor
	mov R4,#3
	ldr R5,LIT_main+80
	str R4,[R5,#0]
	.dbline 115
; 
; /*
; |-------------------------
; | Config I2C Master
; |-------------------------
; */
;   I2C_I2SCLH = 37;                              // I2C clock is 200 KHz (14.7456 MHz/(SCLH + SCLL))
	mov R4,#37
	ldr R5,LIT_main+88
	str R4,[R5,#0]
	.dbline 116
;   I2C_I2SCLL = 37;
	mov R4,#37
	ldr R5,LIT_main+92
	str R4,[R5,#0]
	.dbline 117
;   I2C_I2CONSET = I2C_ENABLE_BIT;                // Enable the I2C channel
	mov R4,#64
	ldr R5,LIT_main+96
	str R4,[R5,#0]
	.dbline 119
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 126
; 
; /*
; |-------------------------
; | Write to the EEPROM
; |-------------------------
; */
; 	EepromWriteByte(0x0001, 0x03);                // Write the EEPROM at address 0x0001 with data 0x03
	mov R0,#1
	mov R1,#3
	bl _EepromWriteByte
	.dbline 127
; 	EepromWriteByte(0x00F0, 0x0F);                // Write the EEPROM at address 0x00F0 with data 0x0F
	mov R0,#240
	mov R1,#15
	bl _EepromWriteByte
	.dbline 128
; 	EepromWriteByte(0x010F, 0x3F);                // Write the EEPROM at address 0x010F with data 0x3F
	ldr R0,LIT_main+100
	mov R1,#63
	bl _EepromWriteByte
	.dbline 129
;   EepromWriteByte(0x1FFF, 0xFF);                // Write the EEPROM at address 0x1FFF with data 0xFF
	ldr R0,LIT_main+104
	mov R1,#255
	bl _EepromWriteByte
	.dbline 131
; 
;   GPIO_IOSET = MICROBOLT_LED;                   // EEPROM written to, turn on MicroBolt LED
	mov R4,#4194304
	ldr R5,LIT_main+108
	str R4,[R5,#0]
	.dbline 132
	mov R4,#0
	ldr R5,LIT_main+112
	str R4,[R5,#0]
	b L6
L3:
	.dbline 132
L4:
	.dbline 132
	ldr R4,LIT_main+112
	ldr R5,[R4,#0]
	add R5,R5,#1
	str R5,[R4,#0]
L6:
	.dbline 132
;   for (Delay = 0; Delay < 370000; Delay++);     // Delay for 100 mS before starting serial routines
	ldr R4,LIT_main+116
	ldr R5,LIT_main+112
	ldr R5,[R5,#0]
	cmp R5,R4
	blo L3
	.dbline 133
;   SerialDebugLed(LED_ON);                       // Turn on MicroBolt serial debugger LED
	mov R0,#1
	bl _SerialDebugLed
	.dbline 134
;   SerialDebug(1,"MicroBolt EEPROM demo");       // Output string to MicroBolt Serial Debugger Debug window 1
	mov R0,#1
	ldr R1,LIT_main+120
	bl _SerialDebug
	b L9
L8:
	.dbline 142
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
;   while(1)                                      // Do this forever
;     {
	.dbline 148
; /*
; |-------------------------
; | Read the EEPROM
; |-------------------------
; */
;     EepromDataValue = EepromReadByte(0x0001);                     // Read the EEPROM at address 0x0001
	mov R0,#1
	bl _EepromReadByte
	mov R4,R0
	ldr R5,LIT_main+124
	strb R4,[R5,#0]
	.dbline 149
;     SerialDebug(2,"Address 0x0001 value: 0x%X", EepromDataValue); // Output string to MicroBolt Serial Debugger Debug window 2
	mov R0,#2
	ldr R1,LIT_main+128
	ldr R4,LIT_main+124
	ldrb R2,[R4,#0]
	bl _SerialDebug
	.dbline 151
; 
;     EepromDataValue = EepromReadByte(0x00F0);                     // Read the EEPROM at address 0x00F0
	mov R0,#240
	bl _EepromReadByte
	mov R4,R0
	ldr R5,LIT_main+124
	strb R4,[R5,#0]
	.dbline 152
;     SerialDebug(3,"Address 0x00F0 value: 0x%X", EepromDataValue); // Output string to MicroBolt Serial Debugger Debug window 3
	mov R0,#3
	ldr R1,LIT_main+132
	ldr R4,LIT_main+124
	ldrb R2,[R4,#0]
	bl _SerialDebug
	.dbline 154
; 
;     EepromDataValue = EepromReadByte(0x010F);                     // Read the EEPROM at address 0x010F
	ldr R0,LIT_main+100
	bl _EepromReadByte
	mov R4,R0
	ldr R5,LIT_main+124
	strb R4,[R5,#0]
	.dbline 155
;     SerialDebug(7,"Address 0x010F value: 0x%X", EepromDataValue); // Output string to MicroBolt Serial Debugger Debug window 7
	mov R0,#7
	ldr R1,LIT_main+136
	ldr R4,LIT_main+124
	ldrb R2,[R4,#0]
	bl _SerialDebug
	.dbline 157
; 
;     EepromDataValue = EepromReadByte(0x1FFF);                     // Read the EEPROM at address 0x1FFF
	ldr R0,LIT_main+104
	bl _EepromReadByte
	mov R4,R0
	ldr R5,LIT_main+124
	strb R4,[R5,#0]
	.dbline 158
;     SerialDebug(8,"Address 0x1FFF value: 0x%X", EepromDataValue); // Output string to MicroBolt Serial Debugger Debug window 8 
	mov R0,#8
	ldr R1,LIT_main+140
	ldr R4,LIT_main+124
	ldrb R2,[R4,#0]
	bl _SerialDebug
	.dbline 160
;     
;     ReadCount++;                                                  // Increment read counter
	ldr R4,LIT_main+144
	ldr R5,[R4,#0]
	add R5,R5,#1
	str R5,[R4,#0]
	.dbline 161
;     SerialDebug(9,"EEPROM reads: %d", ReadCount);                 // Output string to MicroBolt Serial Debugger Debug window 9 
	mov R0,#9
	ldr R1,LIT_main+148
	ldr R4,LIT_main+144
	ldr R2,[R4,#0]
	bl _SerialDebug
	.dbline 163
	mov R4,#0
	ldr R5,LIT_main+112
	str R4,[R5,#0]
	b L19
L16:
	.dbline 163
L17:
	.dbline 163
	ldr R4,LIT_main+112
	ldr R5,[R4,#0]
	add R5,R5,#1
	str R5,[R4,#0]
L19:
	.dbline 163
	ldr R4,LIT_main+152
	ldr R5,LIT_main+112
	ldr R5,[R5,#0]
	cmp R5,R4
	blo L16
	.dbline 164
L9:
	.dbline 141
	b L8
X0:
	.dbline -2
L2:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -534789888
	DCD _pll_isr
	DCD -3840
	DCD -3584
	DCD -4080
	DCD _I2c_ISR
	DCD -3836
	DCD -3580
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707060
	DCD -536821756
	DCD -536821752
	DCD -536821748
	DCD -536821760
	DCD -536756208
	DCD -536756204
	DCD -536756224
	DCD 271
	DCD 8191
	DCD -536707068
	DCD _Delay
	DCD 370000
	DCD L7
	DCD _EepromDataValue
	DCD L11
	DCD L12
	DCD L13
	DCD L14
	DCD _ReadCount
	DCD L15
	DCD 37000
	.dbend
	EXPORT _EepromWriteByte
	.dbfunc e EepromWriteByte _EepromWriteByte fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
; EepromAddressTemp -> R8
;     EepromData -> R6
;  EepromAddress -> R7
_EepromWriteByte:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R7,R8,R11,R12,R14}
	mov R11,R13
	mov R7,R0
	mov R6,R1
	.dbline -1
	.dbline 178
; 
;     for (Delay = 0; Delay < 37000; Delay++);                      // Delay 10 mS between serial data so as not to bog down PC
;     }
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   EepromWriteByte
; |     Inputs          :   EEPROM Address and Data
; |     Outputs         :   None
; |     Purpose         :   Write a byte to the EEPROM
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void EepromWriteByte(unsigned short EepromAddress, unsigned char EepromData)
;   {
	.dbline 185
;   extern unsigned char I2cSlaveAddress;         // I2C slave address
;   extern unsigned char I2cBuffer[20];           // I2C application buffer
;   extern unsigned char I2cPacketDataSize;       // Number of data bytes for an I2C packet
;   extern unsigned char I2cPacketInProgress;	    // I2C Packet in progress flag	
;   unsigned short EepromAddressTemp;             // Temp storage register for address calculation
; 
;   I2cSlaveAddress = I2C_SLAVE_ADDR_EEPROM;      // Address the EEPROM
	mov R4,#160
	ldr R5,LIT_EepromWriteByte+0
	strb R4,[R5,#0]
	.dbline 186
;   I2cPacketDataSize = 3;                        // How many bytes from the I2c buffer to send
	mov R4,#3
	ldr R5,LIT_EepromWriteByte+4
	strb R4,[R5,#0]
	.dbline 188
; 
;   EepromAddressTemp = EepromAddress & 0xFF00;   // Mask top byte of address
	mov R4,R7,lsl #16
	mov R4,R4,lsr #16
	and R4,R4,#65280
	mov R8,R4
	.dbline 189
;   EepromAddressTemp = EepromAddressTemp >> 8;   // Shift it over by 8
	mov R4,R8,lsl #16
	mov R4,R4,lsr #16
	mov R4,R4,asr #8
	mov R8,R4
	.dbline 190
;   I2cBuffer[0] = (unsigned char)EepromAddressTemp;        // MSB address byte for EEPROM
	mov R4,R8,lsl #16
	mov R4,R4,lsr #16
	ldr R5,LIT_EepromWriteByte+8
	strb R4,[R5,#0]
	.dbline 191
;   I2cBuffer[1] = (unsigned char)(EepromAddress & 0x00FF); // LSB address byte for EEPROM
	mov R4,R7,lsl #16
	mov R4,R4,lsr #16
	and R4,R4,#255
	ldr R5,LIT_EepromWriteByte+12
	strb R4,[R5,#0]
	.dbline 193
; 
;   I2cBuffer[2] = EepromData;                    // Data byte for EEPROM
	ldr R4,LIT_EepromWriteByte+16
	strb R6,[R4,#0]
	.dbline 195
; 
;   I2cStart(I2C_WRITE);                          // Send out an I2C Start condition for a Write packet
	mov R0,#0
	bl _I2cStart
L23:
	.dbline 196
L24:
	.dbline 196
;   while(I2cPacketInProgress == TRUE);           // Wait here for I2C packet to complete 
	ldr R4,LIT_EepromWriteByte+20
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L23
	.dbline 198
; 
;   I2cSlaveAckPoll();                            // Go ACK poll the EEPROM and wait for data to be written
	bl _I2cSlaveAckPoll
	.dbline -2
L20:
	ldmfd R11,{R4,R5,R6,R7,R8,R11,SP,PC}
	.dbline 0 ; func end
LIT_EepromWriteByte:
	DCD _I2cSlaveAddress
	DCD _I2cPacketDataSize
	DCD _I2cBuffer
	DCD _I2cBuffer+1
	DCD _I2cBuffer+2
	DCD _I2cPacketInProgress
	.dbsym r EepromAddressTemp 8 s
	.dbsym r EepromData 6 c
	.dbsym r EepromAddress 7 s
	.dbend
	EXPORT _EepromReadByte
	.dbfunc e EepromReadByte _EepromReadByte fc
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
; EepromAddressTemp -> R7
;  EepromAddress -> R6
_EepromReadByte:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R7,R11,R12,R14}
	mov R11,R13
	mov R6,R0
	.dbline -1
	.dbline 212
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   EepromReadByte
; |     Inputs          :   EEPROM Address 
; |     Outputs         :   Byte from the EEPROM
; |     Purpose         :   Read a byte to the EEPROM
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; unsigned char EepromReadByte(unsigned short EepromAddress)
;   {
	.dbline 219
;   extern unsigned char I2cSlaveAddress;         // I2C slave address
;   extern unsigned char I2cBuffer[20];           // I2C application buffer
;   extern unsigned char I2cPacketDataSize;       // Number of data bytes for an I2C packet
;   extern unsigned char I2cPacketInProgress;	    // I2C Packet in progress flag	
;   unsigned short EepromAddressTemp;             // Temp register
; 
;   I2cSlaveAddress = I2C_SLAVE_ADDR_EEPROM;      // Address the EEPROM
	mov R4,#160
	ldr R5,LIT_EepromReadByte+0
	strb R4,[R5,#0]
	.dbline 220
;   I2cPacketDataSize = 2;                        // How many bytes from the I2c buffer to send
	mov R4,#2
	ldr R5,LIT_EepromReadByte+4
	strb R4,[R5,#0]
	.dbline 222
; 
;   EepromAddressTemp = EepromAddress & 0xFF00;   // Mask top byte of address
	mov R4,R6,lsl #16
	mov R4,R4,lsr #16
	and R4,R4,#65280
	mov R7,R4
	.dbline 223
;   EepromAddressTemp = EepromAddressTemp >> 8;   // Shift it over by 8 
	mov R4,R7,lsl #16
	mov R4,R4,lsr #16
	mov R4,R4,asr #8
	mov R7,R4
	.dbline 224
;   I2cBuffer[0] = (unsigned char)EepromAddressTemp;        // MSB address byte for EEPROM
	mov R4,R7,lsl #16
	mov R4,R4,lsr #16
	ldr R5,LIT_EepromReadByte+8
	strb R4,[R5,#0]
	.dbline 225
;   I2cBuffer[1] = (unsigned char)(EepromAddress & 0x00FF); // LSB address byte for EEPROM
	mov R4,R6,lsl #16
	mov R4,R4,lsr #16
	and R4,R4,#255
	ldr R5,LIT_EepromReadByte+12
	strb R4,[R5,#0]
	.dbline 227
; 
;   I2cStart(I2C_WRITE);                          // Send out an I2C Start condition for a Write packet
	mov R0,#0
	bl _I2cStart
L28:
	.dbline 228
L29:
	.dbline 228
;   while(I2cPacketInProgress == TRUE);           // Wait here for I2C packet to complete 
	ldr R4,LIT_EepromReadByte+16
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L28
	.dbline 230
; 
;   I2cSlaveAddress = I2C_SLAVE_ADDR_EEPROM;      // Address the EEPROM
	mov R4,#160
	ldr R5,LIT_EepromReadByte+0
	strb R4,[R5,#0]
	.dbline 231
;   I2cPacketDataSize = 1;                        // How many bytes from the I2c buffer to send
	mov R4,#1
	ldr R5,LIT_EepromReadByte+4
	strb R4,[R5,#0]
	.dbline 233
; 
;   I2cStart(I2C_READ);                           // Send out an I2C Start condition for a Read packet
	mov R0,#1
	bl _I2cStart
L31:
	.dbline 234
L32:
	.dbline 234
;   while(I2cPacketInProgress == TRUE);           // Wait here for I2C packet to complete
	ldr R4,LIT_EepromReadByte+16
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L31
	.dbline 236
; 
;   return(I2cBuffer[0]);                         // Return the byte read from the EEPROM
	ldr R4,LIT_EepromReadByte+8
	ldrb R0,[R4,#0]
	.dbline -2
L26:
	ldmfd R11,{R4,R5,R6,R7,R11,SP,PC}
	.dbline 0 ; func end
LIT_EepromReadByte:
	DCD _I2cSlaveAddress
	DCD _I2cPacketDataSize
	DCD _I2cBuffer
	DCD _I2cBuffer+1
	DCD _I2cPacketInProgress
	.dbsym r EepromAddressTemp 7 s
	.dbsym r EepromAddress 6 s
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 252
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; 
; void pll_isr(void)
;   {
	.dbline 253
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 254
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 255
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 256
;   VICIntEnClear = PLL_CLR;                      // Clear PLL interrupt flag
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 257
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L34:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	IMPORT _I2cPacketInProgress
	IMPORT _I2cPacketDataSize
	IMPORT _I2cBuffer
	IMPORT _I2cSlaveAddress
	AREA	"Cudata", NOINIT
	EXPORT _ReadCount
	ALIGN	4
_ReadCount:
	SPACE 4
	.dbsym e ReadCount _ReadCount i
	EXPORT _Delay
	ALIGN	4
_Delay:
	SPACE 4
	.dbsym e Delay _Delay i
	AREA	"C$$code", CODE, READONLY
L15:
	DCB "EEPROM reads: %d", 0
L14:
	DCB "Address 0x1FFF value: 0x%X", 0
L13:
	DCB "Address 0x010F value: 0x%X", 0
L12:
	DCB "Address 0x00F0 value: 0x%X", 0
L11:
	DCB "Address 0x0001 value: 0x%X", 0
L7:
	DCB "MicroBolt EEPROM demo", 0
	END
