/*
|------------------------------------------------------------------------------------------
|------------------------------------------------------------------------------------------
| File Name			  : MicroBolt_I2C_Functions.h																				
| Author			    : Micromint, Inc.						
| Copyright       : Copyright  2005, Micromint, Inc.																	
| Creation Date		: 12/30/05																							
| Version			    : 1.00																																												
| Spaces per tab	:	2																									
| Description		  : Header file																																									 
| Revision			  :	Initial																																																						
|------------------------------------------------------------------------------------------
|------------------------------------------------------------------------------------------
*/

#ifndef I2C_FUNCTIONS_HEADER_H                          // If not already compiled, compile it                  
#define I2C_FUNCTIONS_HEADER_H

/*
|----------------------------------------------------
|     Function prototypes
|----------------------------------------------------
*/

void I2c_ISR(void);
void I2cStart(unsigned char I2cReadOrWriteNot);
void I2cStop(void);
void I2cSlaveAckPoll(void);

/*
|----------------------------------------------------
|     Defines
|----------------------------------------------------
*/ 

#define I2C_SI_BIT                    0x08              // I2C SI bit
#define I2C_ENABLE_BIT                0x40              // I2C Enable bit
#define I2C_START_BIT                 0x20              // I2C Start bit
#define I2C_STOP_BIT                  0x10              // I2C Stop bit
#define I2C_WRITE                     0x00              // Write is 0x00
#define I2C_READ                      0x01              // Read is 0x01
#define I2C_AA_BIT                    0x04              // I2C Assert Ack bit
#define I2C_SLAVE_ADDR_EEPROM        (0x50 << 1)        // Hard-wired plus internal IC address shifted by 1
 
/*
|----------------------------------------------------
|     Types
|----------------------------------------------------
*/ 

enum
  {
  ACK_POLL_IN_PROGRESS = 1,                             // Misc. Ack poll values 
  I2C_DEVICE_READY                                     
  };  

#endif                                                  // end of I2C_FUNCTIONS_HEADER_H   