	.dbfile C:\iccv7arm\MI5020~1\MicroBolt_I2C_Functions.c
	AREA	"Cidata", DATA
	EXPORT _I2cSlaveAddress
_I2cSlaveAddress:
	DCB 0
	.dbsym e I2cSlaveAddress _I2cSlaveAddress c
	EXPORT _I2cBufferIndex
_I2cBufferIndex:
	DCB 0
	.dbsym e I2cBufferIndex _I2cBufferIndex c
	EXPORT _I2cPacketDataSize
_I2cPacketDataSize:
	DCB 0
	.dbsym e I2cPacketDataSize _I2cPacketDataSize c
	EXPORT _I2cPacketType
_I2cPacketType:
	DCB 0
	.dbsym e I2cPacketType _I2cPacketType c
	EXPORT _I2cPacketInProgress
_I2cPacketInProgress:
	DCB 0
	.dbsym e I2cPacketInProgress _I2cPacketInProgress c
	EXPORT _I2cSlaveStatusAckPoll
_I2cSlaveStatusAckPoll:
	DCB 0
	.dbsym e I2cSlaveStatusAckPoll _I2cSlaveStatusAckPoll c
	AREA	"C$$code", CODE, READONLY
	EXPORT _I2c_ISR
	.dbfunc e I2c_ISR _I2c_ISR fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_I2c_ISR:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R2,R3,R4,R5,R6,R7,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 48
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBolt_I2C_Functions.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 12/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include "MicroBolt_I2C_EEPROM.h"
; #include "MicroBolt_I2C_Functions.h"
; 
; unsigned char I2cSlaveAddress = 0;        // I2C slave address
; unsigned char I2cBuffer[20];              // I2C application buffer
; unsigned char I2cBufferIndex = 0;         // Index for I2C buffer
; unsigned char I2cPacketDataSize = 0;      // Number of data bytes for an I2C packet
; unsigned char I2cPacketType = 0;          // Read or Write packet type
; unsigned char I2cPacketInProgress = 0;	  // I2C Packet in progress flag
; unsigned char I2cSlaveStatusAckPoll = 0;  // I2C device status if ACK Write polling is supported			
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2c_ISR
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   I2C interrupt and command processing
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler I2c_ISR
; 
; void I2c_ISR(void)
; {
	.dbline 49
; 	switch(I2C_I2STAT)
	ldr R4,LIT_I2c_ISR+0
	ldr R7,[R4,#0]
	cmp R7,#48
	beq L15
	cmp R7,#48
	bgt L26
L25:
	cmp R7,#24
	beq L8
	cmp R7,#24
	bgt L28
L27:
	cmp R7,#8
	beq L6
	cmp R7,#8
	blt L3
L29:
	mov R4,R7
	cmp R4,#16
	beq L7
	b L3
L28:
	cmp R7,#32
	beq L14
	cmp R7,#32
	blt L3
L30:
	mov R4,R7
	cmp R4,#40
	beq L11
	b L3
L26:
	cmp R7,#72
	beq L23
	cmp R7,#72
	bgt L32
L31:
	cmp R7,#56
	beq L16
	cmp R7,#56
	blt L3
L33:
	mov R4,R7
	cmp R4,#64
	beq L17
	b L3
L32:
	cmp R7,#80
	beq L20
	cmp R7,#80
	blt L3
L34:
	mov R4,R7
	cmp R4,#88
	beq L24
	b L3
X0:
	.dbline 50
; 			{
L6:
	.dbline 55
; //****************************************************
; // I2C Master Transmit Service Routines
; //****************************************************
; 			case (0x08):																									// START condition transmitted
; 					{
	.dbline 56
; 					I2cBufferIndex = 0;																			  // Reset index counter
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 57
;           I2C_I2DAT = I2cSlaveAddress | I2cPacketType;              // Desired slave address into I2C register OR'd with Read or Write
	ldr R4,LIT_I2c_ISR+8
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+12
	ldrb R5,[R5,#0]
	orr R4,R5,R4
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 58
;       	  I2C_I2CONCLR = I2C_STOP_BIT;	                            // Clear stop bit per datasheet
	mov R4,#16
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 59
; 					break;
	b L4
L7:
	.dbline 63
; 					}
; //------------------------------------
; 			case (0x10):																									// Repeated START condition transmitted
; 					{
	.dbline 64
; 					I2cBufferIndex = 0;																			  // Reset index counter
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 65
;           I2C_I2DAT = I2cSlaveAddress | I2cPacketType;              // Desired slave address into I2C register OR'd with Read or Write
	ldr R4,LIT_I2c_ISR+8
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+12
	ldrb R5,[R5,#0]
	orr R4,R5,R4
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 66
;       	  I2C_I2CONCLR = I2C_STOP_BIT;	                            // Clear stop bit per datasheet
	mov R4,#16
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 67
; 					break;
	b L4
L8:
	.dbline 71
; 					}
; //------------------------------------
; 			case (0x18):																									// Slave address with WRITE transmitted and ACK received
; 					{
	.dbline 72
;           if(I2cSlaveStatusAckPoll == ACK_POLL_IN_PROGRESS)         // Is this an ACK poll?
	ldr R4,LIT_I2c_ISR+24
	ldrb R4,[R4,#0]
	cmp R4,#1
	bne L9
	.dbline 73
;               {
	.dbline 74
;               I2cSlaveStatusAckPoll = I2C_DEVICE_READY;             // Got an ACK for ACK Polling, device now ready
	mov R4,#2
	ldr R5,LIT_I2c_ISR+24
	strb R4,[R5,#0]
	.dbline 75
;               I2cStop();                                            // Done ACK polling, send a stop condition to end packet         
	bl _I2cStop
	.dbline 76
;               }
	b L4
L9:
	.dbline 78
;           else
;               {
	.dbline 79
;               I2C_I2DAT = I2cBuffer[I2cBufferIndex];                // Put data from I2c buffer into I2C register for sending 
	ldr R4,LIT_I2c_ISR+28
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	ldrb R4,[R5,+R4]
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 80
;               I2cBufferIndex++;                                     // Increment the buffer index
	ldr R4,LIT_I2c_ISR+4
	ldrb R5,[R4,#0]
	add R5,R5,#1
	strb R5,[R4,#0]
	.dbline 81
;       	      I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		      // Clear start and stop bits per datasheet
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 82
;               }        
	.dbline 83
;   				break;
	b L4
L11:
	.dbline 87
; 					}
; //------------------------------------
; 			case (0x28):																									// Data byte transmitted and ACK received
; 					{
	.dbline 88
;           I2C_I2DAT = I2cBuffer[I2cBufferIndex];                    // Put data from I2c buffer into I2C register for sending  
	ldr R4,LIT_I2c_ISR+28
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	ldrb R4,[R5,+R4]
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 89
;           I2cBufferIndex++;                                         // Increment the buffer index
	ldr R4,LIT_I2c_ISR+4
	ldrb R5,[R4,#0]
	add R5,R5,#1
	strb R5,[R4,#0]
	.dbline 90
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet  
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 92
; 
;           if (I2cBufferIndex > I2cPacketDataSize)                   // All the bytes from the I2C buffer sent out?
	ldr R4,LIT_I2c_ISR+32
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	cmp R5,R4
	ble L4
	.dbline 93
;       	      {
	.dbline 94
;               I2C_I2CONCLR = I2C_START_BIT;                         // Yes, Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 95
;               I2cStop();                                            // Done sending data, send a stop condition to end packet
	bl _I2cStop
	.dbline 96
;               }
	.dbline 97
; 					break;
	b L4
L14:
	.dbline 101
; 					}
; //------------------------------------
; 			case (0x20):																									// Slave address transmitted and NAK received
; 					{
	.dbline 102
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 103
;           I2cStop();                                                // Done sending data, send a stop condition to end packet
	bl _I2cStop
	.dbline 104
; 					break;
	b L4
L15:
	.dbline 108
; 					}
; //------------------------------------
; 			case (0x30):																									// Data byte transmitted and NAK received
; 					{
	.dbline 109
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 110
;           I2cStop();                                                // Done sending data, send a stop condition to end packet
	bl _I2cStop
	.dbline 111
; 					break;
	b L4
L16:
	.dbline 115
; 					}
; //------------------------------------
; 			case (0x38):																									// Master lost arbitration 
; 					{                                                         // Could send another START if desirable
	.dbline 116
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet 
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 117
; 					break;
	b L4
L17:
	.dbline 125
; 					}
; //------------------------------------
; 
; //****************************************************
; // I2C Master Receive Service Routines
; //****************************************************
; 			case (0x40):																									// Slave address with READ transmitted and ACK received
; 					{
	.dbline 126
; 					if (I2cPacketDataSize <= 1)		                            // Only one byte for the packet?
	ldr R4,LIT_I2c_ISR+32
	ldrb R4,[R4,#0]
	cmp R4,#1
	bgt L18
	.dbline 127
; 					    {
	.dbline 128
; 	            I2C_I2CONCLR = I2C_AA_BIT;                            // Send a NAK, don't want any more bytes
	mov R4,#4
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 129
; 							I2cBufferIndex = 0;													          // Reset count index
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 130
; 							}
	b L19
L18:
	.dbline 132
; 					else
; 							{
	.dbline 133
; 	            I2C_I2CONSET |= I2C_AA_BIT;                           // Send an ACK
	ldr R4,LIT_I2c_ISR+36
	ldr R5,[R4,#0]
	orr R5,R5,#4
	str R5,[R4,#0]
	.dbline 134
; 						  }
L19:
	.dbline 136
; 
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet            
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 137
; 					break;
	b L4
L20:
	.dbline 141
; 					}
; //------------------------------------
; 			case (0x50):																									// Data byte received and ACK returned
; 					{                                                         
	.dbline 142
; 					I2cBuffer[I2cBufferIndex] = I2C_I2DAT;									  // Grab the I2C data and put it into the I2C buffer
	ldr R4,LIT_I2c_ISR+4
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+28
	ldr R6,LIT_I2c_ISR+16
	ldr R6,[R6,#0]
	strb R6,[R4,+R5]
	.dbline 143
;           I2cBufferIndex++;																          // Increment buffer count index
	ldr R4,LIT_I2c_ISR+4
	ldrb R5,[R4,#0]
	add R5,R5,#1
	strb R5,[R4,#0]
	.dbline 144
; 					if (I2cBufferIndex < (I2cPacketDataSize - 1))             // Still more data to come for packet?
	ldr R4,LIT_I2c_ISR+32
	ldrb R4,[R4,#0]
	sub R4,R4,#1
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	cmp R5,R4
	bge L21
	.dbline 145
; 					    {
	.dbline 146
; 	            I2C_I2CONSET |= I2C_AA_BIT;                           // Yes, Send an ACK
	ldr R4,LIT_I2c_ISR+36
	ldr R5,[R4,#0]
	orr R5,R5,#4
	str R5,[R4,#0]
	.dbline 147
; 							}
	b L22
L21:
	.dbline 149
; 					else
; 							{
	.dbline 150
; 	            I2C_I2CONCLR = I2C_AA_BIT;                            // No, Send a NAK, don't want any more bytes
	mov R4,#4
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 151
; 							I2cBufferIndex = 0;													          // Reset count index
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 152
; 						  }
L22:
	.dbline 154
; 
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet 
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 155
; 					break;
	b L4
L23:
	.dbline 159
; 					}
; //------------------------------------
; 			case (0x48):																									// Slave address with READ transmitted and NAK received
; 					{
	.dbline 160
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 161
;           I2cStop();                                                // Send a stop condition to end packet
	bl _I2cStop
	.dbline 162
; 					break;
	b L4
L24:
	.dbline 166
; 					}
; //------------------------------------
; 			case (0x58):																									// Data byte received and NAK returned
; 					{           
	.dbline 167
; 					I2cBuffer[I2cBufferIndex] = I2C_I2DAT;									  // Grab the I2C data and put it into the I2C buffer                                              
	ldr R4,LIT_I2c_ISR+4
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+28
	ldr R6,LIT_I2c_ISR+16
	ldr R6,[R6,#0]
	strb R6,[R4,+R5]
	.dbline 168
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 169
;           I2cStop();                                                // Send a stop condition to end packet
	bl _I2cStop
	.dbline 170
; 					break;
	b L4
L3:
	.dbline 174
; 					}
; //------------------------------------
; 			default:
; 					{
	.dbline 175
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet 
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 176
; 					break;
L4:
	.dbline 181
; 					}
; 			}
; //------------------------------------
; 
; 	I2C_I2CONCLR = I2C_SI_BIT;																		    // Clear I2C SI interrupt flag 
	mov R4,#8
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 182
; 	VICVectAddr = VIC_ACK; 																						// Acknowledge Interrupt
	mov R4,#0
	ldr R5,LIT_I2c_ISR+40
	str R4,[R5,#0]
	.dbline -2
L2:
	ldmfd R13!,{R0,R1,R2,R3,R4,R5,R6,R7,R11,R12,PC}^
	.dbline 0 ; func end
LIT_I2c_ISR:
	DCD -536756220
	DCD _I2cBufferIndex
	DCD _I2cPacketType
	DCD _I2cSlaveAddress
	DCD -536756216
	DCD -536756200
	DCD _I2cSlaveStatusAckPoll
	DCD _I2cBuffer
	DCD _I2cPacketDataSize
	DCD -536756224
	DCD -4048
	.dbend
	EXPORT _I2cStart
	.dbfunc e I2cStart _I2cStart fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
; RequestedI2cPacketType -> R4
_I2cStart:
	mov R12,R13
	stmfd R13!,{R4,R12,R14}
	mov R4,R0
	.dbline -1
	.dbline 196
; }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2cStart
; |     Inputs          :   I2cReadOrWriteNot
; |     Outputs         :   None
; |     Purpose         :   Send a start condition and setup packet type (Read or Write)
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void I2cStart(unsigned char RequestedI2cPacketType)
;   {
	.dbline 197
;   I2cPacketInProgress = TRUE;                   // Flag for stating an I2C packet is about to happen
	mov R0,#1
	ldr R1,LIT_I2cStart+0
	strb R0,[R1,#0]
	.dbline 198
;   I2cPacketType = RequestedI2cPacketType;       // Flag for stating what kind of packet it is; Read, Write, or ACK poll
	ldr R0,LIT_I2cStart+4
	strb R4,[R0,#0]
	.dbline 199
; 	I2C_I2CONSET |= I2C_START_BIT;                // Set the start bit 
	ldr R0,LIT_I2cStart+8
	ldr R1,[R0,#0]
	orr R1,R1,#32
	str R1,[R0,#0]
	.dbline -2
L35:
	ldmfd R13!,{R4,SP,PC}
	.dbline 0 ; func end
LIT_I2cStart:
	DCD _I2cPacketInProgress
	DCD _I2cPacketType
	DCD -536756224
	.dbsym r RequestedI2cPacketType 4 c
	.dbend
	EXPORT _I2cStop
	.dbfunc e I2cStop _I2cStop fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_I2cStop:
	.dbline -1
	.dbline 213
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2cStop
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Send a stop condition
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void I2cStop(void)
;   {
	.dbline 214
; 	I2C_I2CONSET |= I2C_STOP_BIT;                 // Set the stop bit 
	ldr R0,LIT_I2cStop+0
	ldr R1,[R0,#0]
	orr R1,R1,#16
	str R1,[R0,#0]
	.dbline 215
;   I2cPacketInProgress = FALSE;                  // Flag for stating I2C packet is done
	mov R0,#0
	ldr R1,LIT_I2cStop+4
	strb R0,[R1,#0]
	.dbline -2
L36:
	mov R15,R14
	.dbline 0 ; func end
LIT_I2cStop:
	DCD -536756224
	DCD _I2cPacketInProgress
	.dbend
	EXPORT _I2cSlaveAckPoll
	.dbfunc e I2cSlaveAckPoll _I2cSlaveAckPoll fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_I2cSlaveAckPoll:
	mov R12,R13
	stmfd R13!,{R4,R5,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 229
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2cSlaveAckPoll
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Poll the currently addressed I2C slave and wait for an ACK
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void I2cSlaveAckPoll(void)
;   {
	.dbline 230
;   I2cSlaveStatusAckPoll = ACK_POLL_IN_PROGRESS;         // Status set to busy after writing to EEPROM
	mov R4,#1
	ldr R5,LIT_I2cSlaveAckPoll+0
	strb R4,[R5,#0]
	.dbline 231
;   I2cPacketDataSize = 0;                                // No data for an ACK poll, just the current slave address
	mov R4,#0
	ldr R5,LIT_I2cSlaveAckPoll+4
	strb R4,[R5,#0]
	b L39
L38:
	.dbline 234
; 
;   while(I2cSlaveStatusAckPoll == ACK_POLL_IN_PROGRESS)  // Slave still busy?
;       {
	.dbline 235
;       I2cStart(I2C_WRITE);                              // Send out an I2C Start condition Write for an ACK poll
	mov R0,#0
	bl _I2cStart
L41:
	.dbline 236
L42:
	.dbline 236
	ldr R4,LIT_I2cSlaveAckPoll+8
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L41
	.dbline 237
L39:
	.dbline 233
	ldr R4,LIT_I2cSlaveAckPoll+0
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L38
	.dbline -2
L37:
	ldmfd R11,{R4,R5,R11,SP,PC}
	.dbline 0 ; func end
LIT_I2cSlaveAckPoll:
	DCD _I2cSlaveStatusAckPoll
	DCD _I2cPacketDataSize
	DCD _I2cPacketInProgress
	.dbend
	AREA	"Cudata", NOINIT
	EXPORT _I2cBuffer
_I2cBuffer:
	SPACE 20
	.dbsym e I2cBuffer _I2cBuffer A[20:20]c
	END
